"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createDoneCallBack = exports.saveProjectConfigJson = exports.runPrepare = void 0;
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
const common_1 = require("../types/common");
const junk = __importStar(require("../util/junk"));
function runPrepare(buildTypeList, appBuildDir, isCleanDistDir) {
    return __awaiter(this, void 0, void 0, function* () {
        console.time('runPrepare');
        const projectConfig = yield saveProjectConfigJson(appBuildDir);
        try {
            if (buildTypeList.includes("mp")) {
                const mpDirPath = path_1.default.resolve(appBuildDir, './dist/mp');
                if (projectConfig && projectConfig.cloudfunctionRoot) {
                }
                else {
                    yield fs_extra_1.default.emptyDir(mpDirPath);
                }
                const dirs = fs_extra_1.default.readdirSync(mpDirPath).filter(junk.not);
                yield Promise.all(dirs.map((dir) => __awaiter(this, void 0, void 0, function* () {
                    if (projectConfig && projectConfig.cloudfunctionRoot) {
                        if (projectConfig.cloudfunctionRoot.startsWith(dir)) {
                            return;
                        }
                    }
                    if (dir === 'miniprogram_npm') {
                        return;
                    }
                    yield fs_extra_1.default.remove(path_1.default.resolve(mpDirPath, dir));
                })));
            }
            if (common_1.buildAsWebByBuildType(buildTypeList)) {
                yield fs_extra_1.default.emptyDir(path_1.default.resolve(appBuildDir, './preview'));
            }
        }
        catch (e) {
            console.error('清空 dist/preview 目录失败', e);
        }
        if (isCleanDistDir) {
            yield fs_extra_1.default.remove(path_1.default.resolve(appBuildDir, './src'));
            yield fs_extra_1.default.remove(path_1.default.resolve(appBuildDir, './webpack'));
            yield fs_extra_1.default.remove(path_1.default.resolve(appBuildDir, './package-lock.json'));
            yield fs_extra_1.default.remove(path_1.default.resolve(appBuildDir, './yarn.lock'));
        }
        yield fs_extra_1.default.ensureDir(appBuildDir);
        console.timeEnd('runPrepare');
        return projectConfig;
    });
}
exports.runPrepare = runPrepare;
function saveProjectConfigJson(appBuildDir) {
    return __awaiter(this, void 0, void 0, function* () {
        const projectConfigJsonPath = path_1.default.resolve(appBuildDir, './dist/mp/project.config.json');
        if (fs_extra_1.default.existsSync(projectConfigJsonPath)) {
            return yield fs_extra_1.default.readJSON(projectConfigJsonPath);
        }
        return null;
    });
}
exports.saveProjectConfigJson = saveProjectConfigJson;
function createDoneCallBack({ projectConfig, appBuildDir }, cb) {
    return (...params) => __awaiter(this, void 0, void 0, function* () {
        if (projectConfig) {
            const newProjectConfig = yield saveProjectConfigJson(appBuildDir);
            if (newProjectConfig) {
                newProjectConfig.condition = projectConfig.condition;
                const projectConfigJsonPath = path_1.default.resolve(appBuildDir, './dist/mp/project.config.json');
                yield fs_extra_1.default.writeFile(projectConfigJsonPath, JSON.stringify(newProjectConfig, null, 4), {
                    encoding: 'utf8',
                });
            }
        }
        cb && cb(...params);
    });
}
exports.createDoneCallBack = createDoneCallBack;
