import { IWeAppComponentInstance } from './app';
import { IWeAppCode } from './lowcode';
export interface ICompLibCommonResource {
    theme: {
        variable: string;
        class: string;
    };
    class: string;
    const: IWeAppCode;
    tools: IWeAppCode;
    npm: {
        [key: string]: string;
    };
}
export interface IMaterialItem {
    compLibCommonResource: ICompLibCommonResource;
    name: string;
    version: string;
    srcZipUrl: string;
    mpPkgUrl: string;
    actions: {
        name: string;
    }[];
    components: ICompositedComponent[];
    isComposite?: boolean;
    isMiniProgramPlugins?: boolean;
    styles?: string[];
    dependencies?: {};
    schemaVersion?: string;
    meta?: Record<string, any>;
    componentInstances?: IWeAppComponentInstance[];
}
export interface ICompositedComponent {
    id: number;
    name: string;
    materialName: string;
    componentInstances: {
        [key: string]: IWeAppComponentInstance;
    };
    compConfig: Record<string, any>;
    dataForm: any;
    evnets?: any[];
    emitEvents: any[];
    listeners: any[];
    lowCodes: IWeAppCode[];
    meta: IComponentMeta;
    npmDependencies: any;
}
export interface IDependencies {
    [key: string]: string;
}
export interface IComponentMeta {
    title: string;
    desc?: string;
    category?: string;
    categoryOrder?: number;
    componentOrder?: number;
    inputProps: {
        [valuePropName: string]: IPropSynConfig;
    };
    syncProps: {
        [valuePropName: string]: IPropSynConfig | IPropSynConfig[];
    };
    platforms: {
        mp: {
            tagName?: string;
            path?: string;
        };
    };
    mustEmptyStyle?: boolean;
}
interface IPropSynConfig {
    changeEvent: string;
    valueFromEvent: string;
    isFormField?: boolean;
}
export interface IGenericComp {
    propName: string;
    title: string;
}
export declare const COMPONENT_API_PREFIX = "this.$WEAPPS_COMP";
export declare const PAGE_API_PREFIX = "this";
export declare function getCompositedComponentClass(comp: ICompositedComponent): string;
export {};
//# sourceMappingURL=material.d.ts.map